//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Orignial by Lacry
// Remade by sprinkles
// Modified by Le Codex


IncludeScript("copsandrobbers/util/util.nut")

//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------

::m_aRedPlayers <- [];
::m_aFakeDeadPlayers <- [];
::m_aCellA <- [];
::m_aCellB <- [];
::m_iPrisoners <- 0;
::m_iPrisonersCellA <- 0;
::m_iPrisonersCellB <- 0;
::m_hEscrots <- null;
::m_flJailTime <- Time();

::TF_TEAM_GUARDS <- TF_TEAM_BLUE;
::TF_TEAM_PRISONER <- TF_TEAM_RED;

::DEAD_RINGER_FLAG <- 32;

::m_bRoundActive <- false;
::m_bGlowEnabled <- false;

::m_bPassiveUber <- true;
::m_flPassiveUberAmount <- 0.01;
::m_flPassiveUberAmountCap <- 1.0;

::m_bLastManActive <- false;
::m_hLastMan <- null;

::m_hLastCellAOpener <- null;
::m_hLastCellBOpener <- null;

::m_hCellATrigger <- Entities.FindByName(null, "cell_red_A");
::m_hCellBTrigger <- Entities.FindByName(null, "cell_red_B");
::m_hTimer <- Entities.FindByName(null, "game_timer");
::m_hCPCellA <- Entities.FindByName(null, "switch_red_A_cp");
::m_hCPCellB <- Entities.FindByName(null, "switch_red_B_cp");

::m_hCellASpawn <- Entities.FindByName(null, "spawn_red_A");
::m_hCellBSpawn <- Entities.FindByName(null, "spawn_red_B");

::m_bDevMode <- IsInDebugMode();

::m_aLastManLines <- [
	"Announcer.AM_LastManAlive01",
	"Announcer.AM_LastManAlive02",
	"Announcer.AM_LastManAlive03",
	"Announcer.AM_LastManAlive04"
];

//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Purpose: This function is called when the entity is spawned in
//-----------------------------------------------------------------------------
function OnPostSpawn()
{

}

//-----------------------------------------------------------------------------
// Purpose: Alt Think function that is called every second
//-----------------------------------------------------------------------------
function JailThinkFunction(array, intcell)
{
	if(intcell != 0)
	{
		for (local i = 0; i <= (intcell - 1); i++)
		{
			local m_hPlayer = array[i]
			if (m_hPlayer != null)
			{
				for (local i = 0; i < 8; i++)
				{
					local weapon = GetPropEntityArray(m_hPlayer, "m_hMyWeapons", i)
					if (weapon != null)
					{
						if ((weapon.GetClassname() == "tf_weapon_medigun") && m_bPassiveUber)
						{
							if (GetPropFloat(weapon, "m_flChargeLevel") < m_flPassiveUberAmountCap)
							{
								local m_flChargeLevel = (GetPropFloat(weapon, "m_flChargeLevel") + (m_flPassiveUberAmount * weapon.GetAttribute("ubercharge rate bonus", 1.0)) )
								SetPropFloat(weapon, "m_flChargeLevel", m_flChargeLevel)
							}
							else
							{
								SetPropFloat(weapon, "m_flChargeLevel", m_flPassiveUberAmountCap)
							}
						}
					}
				}
				SetPropFloat(m_hPlayer, "m_Shared.m_flEnergyDrinkMeter", 100)
				SetPropFloat(m_hPlayer, "m_Shared.m_flChargeLevel", 100)
			}
		}
	}
}

//-----------------------------------------------------------------------------
// Purpose: Think function that counts player and handles the lastman mechanic
//-----------------------------------------------------------------------------
function count_players()
{
	local m_flTimeRemaining = !GetPropBool(m_hTimer, "m_bTimerPaused") ? GetPropFloat(m_hTimer, "m_flTimerEndTime") - Time() : GetPropFloat(m_hTimer, "m_flTimeRemaining");

	// these must be at the top to always have the latest amount of players in each array
	// put anything that doesn't require the latest value above this
	m_iPrisoners = m_aRedPlayers.len();
	m_iPrisonersCellA = m_aCellA.len();
	m_iPrisonersCellB = m_aCellB.len();

	if (!m_bRoundActive)
	{
		return -1;
	}
	else
	{
		/*
		if (m_flJailTime < Time() )
		{
			if(m_iPrisonersCellA != 0)
			{
				JailThinkFunction(m_aCellA, m_iPrisonersCellA)
			}

			if(m_iPrisonersCellB != 0)
			{
				JailThinkFunction(m_aCellB, m_iPrisonersCellB)
			}
			//DebugPrintl("Tick!")
			m_flJailTime = Time() + 1.0
		}
		*/
		if (m_flTimeRemaining <= 30)
		{
			if(!m_bGlowEnabled)
			{
				m_bGlowEnabled = true;
				SetGlowAll();
			}
		}

		
		if (m_iPrisoners == 0) // there is no red players left standing tell the game blue wins!
		{
			winner_logic("blue");
		}
		else if (m_flTimeRemaining <= 0) // time is up, so red wins (overrides the overtime taht can be triggered by the control points)
		{
			winner_logic("red");
		}
		else if (m_iPrisoners == 1) // there is one player left on red team give him the last man bonus!
		{
			if(!m_bLastManActive)
			{
				m_hLastMan = m_aRedPlayers[0];

				m_hLastMan.AddCond(TF_COND_OFFENSEBUFF);
				m_hLastMan.AddCond(TF_COND_DEFENSEBUFF);
				m_hLastMan.AddCond(TF_COND_REGENONDAMAGEBUFF);
				DoEntFire("gamerules", "PlayVORed", m_aLastManLines[RandomInt(0, 3)], 0, null, null);
				DebugPrintl("player " + m_hLastMan.GetPlayerName() + " is the last man!");
				m_bLastManActive = true;
			}
		}
		else if (m_iPrisoners >= 1) // more the one red player left, if there was a last man remove the bonus
		{
			if(m_bLastManActive)
			{
				m_hLastMan.RemoveCond(TF_COND_OFFENSEBUFF);
				m_hLastMan.RemoveCond(TF_COND_DEFENSEBUFF);
				m_hLastMan.RemoveCond(TF_COND_REGENONDAMAGEBUFF);
				DebugPrintl("player " + m_hLastMan.GetPlayerName() + " has lost the last man bonus!");
				m_bLastManActive = false;
				m_hLastMan = null;
			}
		}

		for (local i = m_aFakeDeadPlayers.len() - 1; i >= 0; i--)
		{
			local hPlayer = m_aFakeDeadPlayers[i];
			if (!hPlayer.InCond(TF_COND_STEALTHED))
			{
				printl("Removing" + hPlayer)
				m_aFakeDeadPlayers.remove(i);
				local hParticle = PlayerPropGlowArray[hPlayer.entindex() - 1];
				if (hParticle)
				{
					hParticle.AcceptInput("Start", "", hPlayer, hPlayer);
				}
				continue;
			}
			m_iPrisoners--;
		}

		SetPropInt(self, "m_nRedScore", m_iPrisoners);
		SetPropInt(self, "m_nBlueScore", m_iPrisonersCellA);
		SetPropInt(self, "m_nMaxPoints", m_iPrisonersCellB);

		return -1;
	}

	return -1;
}

//-----------------------------------------------------------------------------
// Purpose: opening of cell logic, give player the halloween overheal effect
// the person who opens the cell gets score and gets ownership of the effect
//-----------------------------------------------------------------------------
function OpenCellLogic(cell)
{
	local m_CP = cell == 0 ? m_hCPCellA : m_hCPCellB
	local m_hCellOpener = FindNearestAlivePlayer(m_CP.GetOrigin());

	if (cell == 0)
	{
		m_hLastCellAOpener = m_hCellOpener;
		m_hCellOpener.ScorePoints(m_iPrisonersCellA);
		EntFireByHandle(m_hCPCellA, "SetOwner", "3", 4, Entities.First(), Entities.First());
	}
	else if (cell == 1)
	{
		m_hLastCellBOpener = m_hCellOpener;
		m_hCellOpener.ScorePoints(m_iPrisonersCellB);
		EntFireByHandle(m_hCPCellB, "SetOwner", "3", 4, Entities.First(), Entities.First());
	}
	else
	{
		DebugError("Out of range! do a value less then 1!");
	}
}

//-----------------------------------------------------------------------------
// Purpose: give escape bonuses
//-----------------------------------------------------------------------------
function Escape(m_hPlayer, m_hCellOpener)
{
	if (MovePlayerToGroup(m_hPlayer, m_aRedPlayers)) {
		m_hPlayer.RemoveCond(TF_COND_PHASE);
		m_hPlayer.RemoveCond(TF_COND_STUNNED);
		m_hPlayer.SetForcedTauntCam(0);
		// m_hPlayer.AddCondEx(TF_COND_INVULNERABLE_HIDE_UNLESS_DAMAGED, 2, m_hCellOpener);
		m_hPlayer.AddCondEx(TF_COND_INVULNERABLE_USER_BUFF, 2, m_hCellOpener);
		// m_hPlayer.AddCondEx(TF_COND_HALLOWEEN_QUICK_HEAL, 5, m_hCellOpener);
		m_hPlayer.AddCondEx(TF_COND_IMMUNE_TO_PUSHBACK, 2, m_hCellOpener);
		SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 0);
		DebugPrintl(m_hPlayer.GetPlayerName() + " free from cell");
	}
}

// Sets Winner/Loser (By killing)
function winner_logic(team)
{
	if (m_bRoundActive)
	{
		DoEntFire("game_win_" + team, "RoundWin", "", 0, null, null);
		m_bRoundActive = false;
	}

	return;
}

//-----------------------------------------------------------------------------
// Purpose: Adds a RED player to one of the groups (free, cellA, cellB) and removes them
// from all other groups, or removes them from all the groups if aPlayerGroup is null
// Input : A player instance, and one of the three group arrays (or null)
// Output : Returns whether any change happened
//-----------------------------------------------------------------------------
function MovePlayerToGroup(hPlayer, aPlayerGroup)
{
	if (aPlayerGroup)
	{
		local index = aPlayerGroup.find(hPlayer);
		if (index != null)
		{
			return false;
		}
	}

	local indexFree = m_aRedPlayers.find(hPlayer);
	if (indexFree != null)
	{
		m_aRedPlayers.remove(indexFree);
	}

	local indexA = m_aCellA.find(hPlayer);
	if (indexA != null)
	{
		m_aCellA.remove(indexA);
	}

	local indexB = m_aCellB.find(hPlayer);
	if (indexB != null)
	{
		m_aCellB.remove(indexB);
	}

	if (aPlayerGroup)
	{
		aPlayerGroup.append(hPlayer);
	}

	return true;
}

//-----------------------------------------------------------------------------
// Purpose: Update the button CP name based on the number of prisoners
//-----------------------------------------------------------------------------
function UpdateCellName(cell)
{
	if (cell == 0)
	{
		local iAmount = m_aCellA.len()
		SetPropString(m_hCPCellA, "m_iszPrintName", "the A Prison Cell and freed " + iAmount + " player" + (iAmount > 1 ? "s" : "") + "!");
	}
	else
	{
		local iAmount = m_aCellB.len()
		SetPropString(m_hCPCellB, "m_iszPrintName", "the B Prison Cell and freed " + iAmount + " player" + (iAmount > 1 ? "s" : "") + "!");
	}
}

function Precache()
{
	PrecacheParticle("cr_plr_mark_ico");
	PrecacheParticle("cr_plr_mark_ico_scout");
	PrecacheParticle("cr_plr_mark_ico_sniper");
	PrecacheParticle("cr_plr_mark_ico_soldier");
	PrecacheParticle("cr_plr_mark_ico_pyro");
	PrecacheParticle("cr_plr_mark_ico_medic");
	PrecacheParticle("cr_plr_mark_ico_engie");
	PrecacheParticle("cr_plr_mark_ico_heavy");
	PrecacheParticle("cr_plr_mark_ico_demo");
}

::PlayerPropGlowArray <- array(52);

::SetGlowAll <- function()
{
	for (local i = 1; i <= m_iMaxPlayers; i++)
	{
		local m_hPlayer = PlayerInstanceFromIndex(i);
		if (m_hPlayer != null)
		{
			PlayerPropGlowArray[m_hPlayer.entindex() - 1].AcceptInput("start", "", null, null);
			SetPropBool(m_hPlayer, "m_bGlowEnabled", true);
		}
	}
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////
	OnGameEvent_player_say = function(params) //debug and test command only the CR devs should use these
	{
		local m_hPlayer = GetPlayerFromUserID(params.userid)
		local szMessage = params.text

		switch (m_hPlayer.GetPlayerSteamID()) {
			case "[U:1:94791175]": //sprinkles
			case "[U:1:468362759]": //seacat
			case "[U:1:152416652]": //lacry
			{
				switch (arraysplit(split(szMessage.tolower(), " ", false)))
				{
					case "!jailuber":
					case "jailuber":
					case "/jailuber":
					{
						switch (m_bPassiveUber) {
							case false:
								m_bPassiveUber = true
								ClientPrint(null, 3, "Passive ÜberCharge in jail is enabled!")
								break;
							case true:
								ClientPrint(null, 3, "Passive ÜberCharge in jail is disabled!")
								m_bPassiveUber = false
								break;
						}
						break;
					}
					case "!jailuberamount":
					case "jailuberamount":
					case "/jailuberamount":
					{
						local m_iUberNumber = arraysplit(split(szMessage.tolower(), " ", false), 1 ).tointeger()

						if(m_iUberNumber < 0)
						{
							DebugError("less then 0 changing it to 0!")
							m_iUberNumber = 0
						}
						else if(m_iUberNumber > 100)
						{
							DebugError("more then 100 changing it to 100!")
							m_iUberNumber = 100
						}

						m_flPassiveUberAmount = m_iUberNumber.tofloat() / 100
						ClientPrint(null, 3, "Passive ÜberCharge amount per second is " + m_iUberNumber + "%")
						break;
					}
					case "!jailubercap":
					case "jailubercap":
					case "/jailubercap":
					{
						local m_iUberNumber = arraysplit(split(szMessage.tolower(), " ", false), 1 ).tointeger()

						if(m_iUberNumber < 0)
						{
							DebugError("less then 0 changing it to 0!")
							m_iUberNumber = 0
						}
						else if(m_iUberNumber > 100)
						{
							DebugError("more then 100 changing it to 100!")
							m_iUberNumber = 100
						}

						m_flPassiveUberAmountCap = m_iUberNumber.tofloat() / 100
						ClientPrint(null, 3, "Passive ÜberCharge amount can only go to " + m_iUberNumber + "%")
						break;
					}
					default:
						break;
				}
				break;
			}
			default:
				break;
		}
	}

	OnGameEvent_player_spawn = function(params)
	{
		local m_hPlayer = GetPlayerFromUserID(params.userid);
		if (!m_hPlayer)
			return;

		if (m_hPlayer.GetTeam() == TF_TEAM_GUARDS)
			return;

		if (m_hPlayer.GetTeam() == 0)
			return;

		if(!m_bRoundActive)
		{
			if (MovePlayerToGroup(m_hPlayer, m_aRedPlayers)) {
				DebugPrintl("OnGameEvent_player_spawn player " + m_hPlayer.GetPlayerName() + " has been added to the red team array they are on the " + m_hPlayer.GetTeam() + " team");
			}
		}
		else
		{
			// They're already in a cell: send them back into it
			local indexA = m_aCellA.find(m_hPlayer);
			if (indexA != null)
			{
				m_hPlayer.SetAbsOrigin(m_hCellASpawn.GetOrigin());
				m_hPlayer.SnapEyeAngles(m_hCellASpawn.GetAbsAngles());
				return;
			}

			local indexB = m_aCellB.find(m_hPlayer);
			if (indexB != null)
			{
				m_hPlayer.SetAbsOrigin(m_hCellBSpawn.GetOrigin());
				m_hPlayer.SnapEyeAngles(m_hCellBSpawn.GetAbsAngles());
				return;
			}

			// They're not in a cell: put them in the one with the least guards around it
			local iCellAGuards = 0, iCellBGuards = 0;
			for (local i = 1; i <= m_iMaxPlayers ; i++)
			{
				local m_hPlayer = PlayerInstanceFromIndex(i)
				if (m_hPlayer != null && m_hPlayer.GetTeam() == TF_TEAM_GUARDS)
				{
					if (Distance3D(m_hPlayer.GetOrigin(), m_hCellASpawn.GetOrigin()) < Distance3D(m_hPlayer.GetOrigin(), m_hCellBSpawn.GetOrigin()))
					{
						iCellAGuards++;
					}
					else
					{
						iCellBGuards++;
					}
				}
			}

			if (iCellAGuards <= iCellBGuards)
			{
				m_hPlayer.SetAbsOrigin(m_hCellASpawn.GetOrigin());
				m_hPlayer.SnapEyeAngles(m_hCellASpawn.GetAbsAngles());
				DebugPrintl("cell_red_A");
				//m_hPlayer.AddCond(TF_COND_PHASE);
				//m_hPlayer.AddCond(TF_COND_STUNNED);
				//m_hPlayer.SetDelayedFunction("activator.SetForcedTauntCam(1)", 0.2);
				//m_hPlayer.StunPlayer(Time() + 9999, 0.5, 1 + 2 + 8 + 64, null)
				//SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 256 + 64);
			}
			else
			{
				m_hPlayer.SetAbsOrigin(m_hCellBSpawn.GetOrigin());
				m_hPlayer.SnapEyeAngles(m_hCellBSpawn.GetAbsAngles());
				DebugPrintl("cell_red_B");
				//m_hPlayer.AddCond(TF_COND_PHASE);
				//m_hPlayer.AddCond(TF_COND_STUNNED);
				//m_hPlayer.SetDelayedFunction("activator.SetForcedTauntCam(1)", 0.2);
				//m_hPlayer.StunPlayer(Time() + 9999, 0.5, 1 + 2 + 8 + 64, null)
				//SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 256 + 64);
			}
		}
	}

	OnGameEvent_post_inventory_application = function(params)
	{
		local m_hPlayer = GetPlayerFromUserID(params.userid)
		if (!m_hPlayer)
			return

		local effectname = "cr_plr_mark_ico_scout"
		switch (m_hPlayer.GetPlayerClass()) {
			case 1:
				effectname = "cr_plr_mark_ico_scout"
				break;
			case 2:
				effectname = "cr_plr_mark_ico_sniper"
				break;
			case 3:
				effectname = "cr_plr_mark_ico_soldier"
				break;
			case 4:
				effectname = "cr_plr_mark_ico_demo"
				break;
			case 5:
				effectname = "cr_plr_mark_ico_medic"
				break;
			case 6:
				effectname = "cr_plr_mark_ico_heavy"
				break;
			case 7:
				effectname = "cr_plr_mark_ico_pyro"
				break;
			case 8:
				effectname = "cr_plr_mark_ico_spy"
				break;
			case 9:
				effectname = "cr_plr_mark_ico_engie"
				break;
			default:
				effectname = "cr_plr_mark_ico_scout"
				break;
		}

		local hParticle = PlayerPropGlowArray[m_hPlayer.entindex() - 1];
		if (hParticle == null)
		{
			hParticle = PlayerPropGlowArray[m_hPlayer.entindex() - 1] = SpawnEntityFromTable("info_particle_system", {
				start_active = 0,
				effect_name = effectname,
				origin = m_hPlayer.GetOrigin(),
			});
			SetPropEntity(hParticle, "m_hOwnerEntity", m_hPlayer);
			EntFireByHandle(hParticle, "SetParent", "!activator", 0, m_hPlayer, m_hPlayer);
		}
		else
		{
			hParticle.KeyValueFromString("effect_name", effectname);
			if (m_bGlowEnabled)
			{
				hParticle.AcceptInput("Start", "", m_hPlayer, m_hPlayer);
			}
		}
	}

	OnGameEvent_player_death = function(params)
	{
		local m_hPlayer = GetPlayerFromUserID(params.userid);
		if (!m_hPlayer)
			return;

		local hParticle = PlayerPropGlowArray[m_hPlayer.entindex() - 1];
		if (hParticle)
		{
			hParticle.AcceptInput("Stop", "", m_hPlayer, m_hPlayer);
		}

		if (m_hPlayer.GetTeam() == TF_TEAM_GUARDS)
			return;

		if (!m_bRoundActive)
			return;

		if (params.death_flags & DEAD_RINGER_FLAG)
		{
			local index = m_aFakeDeadPlayers.find(m_hPlayer);
			if (index == null)
			{
				m_aFakeDeadPlayers.append(m_hPlayer);
			}
			return;
		}

		local index = m_aRedPlayers.find(m_hPlayer);
		if (index != null)
		{
			m_aRedPlayers.remove(index);
		}
	}

	OnGameEvent_player_team = function(params)
	{
		local m_hPlayer = GetPlayerFromUserID(params.userid);
		if (!m_hPlayer)
			return;

		local m_iOldteam = params.oldteam;
		local m_iNewteam = params.team;
		if(m_iOldteam == TF_TEAM_PRISONER)
		{
			MovePlayerToGroup(m_hPlayer, null);
		}
		else if (m_iNewteam == TF_TEAM_PRISONER)
		{
			DebugPrintl("OnGameEvent_player_team player " + m_hPlayer.GetPlayerName() + " has been added to the red team array they are on the " + m_hPlayer.GetTeam() + " team");
			MovePlayerToGroup(m_hPlayer, m_aRedPlayers);
		}

		//DebugPrintl(params.team);
		//DebugPrintl(params.oldteam);
	}

	OnScriptHook_OnTakeDamage = function(params)
	{
		local m_hInflictor = params.inflictor
		local m_hAttacker = params.attacker
		local m_hDamagetaker = params.const_entity

		SetPropBool(m_hInflictor, "m_bForcePurgeFixedupStrings", true);
		SetPropBool(m_hAttacker, "m_bForcePurgeFixedupStrings", true);
		SetPropBool(m_hDamagetaker, "m_bForcePurgeFixedupStrings", true);

		if ( m_hDamagetaker == null || m_hInflictor == null || m_hAttacker == null )
	   		return;


		// if (m_hDamagetaker.GetPlayerSteamID() == "[U:1:468362759]")
		// {
		// 	params.damage = params.damage + 3
		// }

		// if (m_hAttacker.GetPlayerSteamID() == "[U:1:468362759]")
		// {
		// 	params.damage = params.damage - 3
		// }

	}

	OnGameEvent_teamplay_setup_finished = function(params)
	{
		m_bRoundActive = true;
	}
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)
